Template Numerical Library: TNL::Meshes::DistributedMeshes::DistributedMesh< Grid< Dimension, Real, Device, Index > > Class Template Reference

Template Numerical Library version\ main:be7e16d88

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Attributes | List of all members
TNL::Meshes::DistributedMeshes::DistributedMesh< Grid< Dimension, Real, Device, Index > > Class Template Reference
Inheritance diagram for TNL::Meshes::DistributedMeshes::DistributedMesh< Grid< Dimension, Real, Device, Index > >:
[legend]
Collaboration diagram for TNL::Meshes::DistributedMeshes::DistributedMesh< Grid< Dimension, Real, Device, Index > >:
[legend]

## Public Types
using | Cell
using | Config
using | CoordinatesType = Containers::StaticVector< Dimension, IndexType >
using | DeviceType = Device
using | Face
using | GlobalIndexArray
using | GlobalIndexType = Index
using | GridType = Grid< Dimension, Real, Device, IndexType >
using | IndexType = Index
using | LocalIndexType
using | MeshType
using | PointType = typename GridType::PointType
using | RealType = Real
using | SubdomainOverlapsType = Containers::StaticVector< Dimension, IndexType >
using | Vertex
using | VTKTypesArrayType

## Public Member Functions
const MPI::Comm & | getCommunicator () const
const CoordinatesType & | getDomainDecomposition () const
template<typename Entity>
IndexType | getEntitiesCount () const
template<int EntityDimension>
IndexType | getEntitiesCount () const
int | getGhostLevels () const
const CoordinatesType & | getGlobalBegin () const
const GridType & | getGlobalGrid () const
const GlobalIndexArray & | getGlobalIndices () const
const CoordinatesType & | getGlobalSize () const
const GridType & | getLocalMesh () const
const CoordinatesType & | getLocalSize () const
const SubdomainOverlapsType & | getLowerOverlap () const
const int * | getNeighbors () const
const int * | getPeriodicNeighbors () const
int | getRankOfProcCoord (const CoordinatesType &nodeCoordinates) const
const CoordinatesType & | getSubdomainCoordinates () const
const SubdomainOverlapsType & | getUpperOverlap () const
bool | isBoundarySubdomain () const
bool | isDistributed () const
bool | isThereNeighbor (const CoordinatesType &direction) const
bool | operator!= (const DistributedMesh &other) const
DistributedMesh & | operator= (const DistributedMesh &)=default
bool | operator== (const DistributedMesh &other) const
void | printInfo (std::ostream &str) const
String | printProcessCoords () const
String | printProcessDistr () const
void | reorderEntities (const GlobalIndexArray &perm, const GlobalIndexArray &iperm)
void | setCommunicator (const MPI::Comm &communicator)
void | setDomainDecomposition (const CoordinatesType &domainDecomposition)
void | setGhostLevels (int levels)
void | setGlobalGrid (const GridType &globalGrid)
void | setOverlaps (const SubdomainOverlapsType &lower, const SubdomainOverlapsType &upper)
template<typename DistributedGridType>
bool | SetupByCut (DistributedGridType &inputDistributedGrid, Containers::StaticVector< Dimension, int > savedDimensions, Containers::StaticVector< DistributedGridType::getMeshDimension() - Dimension, int > reducedDimensions, Containers::StaticVector< DistributedGridType::getMeshDimension() - Dimension, IndexType > fixedIndexes)
void | setupNeighbors ()
VTKTypesArrayType & | vtkCellGhostTypes ()
VTKTypesArrayType & | vtkPointGhostTypes ()
void | writeProlog (Logger &logger)

## Static Public Member Functions
static constexpr int | getMeshDimension ()
static constexpr int | getNeighborsCount ()

## Public Attributes
MPI::Comm | communicator = MPI_COMM_WORLD
bool | distributed = false
CoordinatesType | domainDecomposition = 0
CoordinatesType | globalBegin = 0
GridType | globalGrid
bool | isSet = false
GridType | localGrid
CoordinatesType | localSize = 0
SubdomainOverlapsType | lowerOverlap = 0
int | neighbors [getNeighborsCount()]
int | periodicNeighbors [getNeighborsCount()]
CoordinatesType | subdomainCoordinates = 0
SubdomainOverlapsType | upperOverlap = 0

## Protected Attributes
int | ghostLevels
MeshType | localMesh
VTKTypesArrayType | vtkCellGhostTypesArray
VTKTypesArrayType | vtkPointGhostTypesArray

## Additional Inherited Members
Protected Member Functions inherited from TNL::Meshes::DistributedMeshes::GlobalIndexStorageFamily< Mesh, Device, DimensionTag >
| GlobalIndexStorageFamily (const GlobalIndexStorageFamily &)=default
| GlobalIndexStorageFamily (GlobalIndexStorageFamily &&) noexcept=default
GlobalIndexStorageFamily & | operator= (const GlobalIndexStorageFamily &)=default
template<typename Mesh_>
GlobalIndexStorageFamily & | operator= (const Mesh_ &mesh)
GlobalIndexStorageFamily & | operator= (GlobalIndexStorageFamily &&) noexcept=default
bool | operator== (const GlobalIndexStorageFamily &other) const

The documentation for this class was generated from the following file:

- src/TNL/Meshes/DistributedMeshes/DistributedGrid.h